diff --git a/pengine/test10/whitebox-fail1.dot b/pengine/test10/whitebox-fail1.dot
index 0f0fe26f6..c6380ea55 100644
--- a/pengine/test10/whitebox-fail1.dot
+++ b/pengine/test10/whitebox-fail1.dot
@@ -25,11 +25,9 @@ digraph "g" {
 "all_stopped" [ style=bold color="green" fontcolor="orange"]
 "container1_start_0 18node2" -> "lxc1_start_0 18node2" [ style = bold]
 "container1_start_0 18node2" [ style=bold color="green" fontcolor="black"]
-"container1_stop_0 18node2" -> "B_stop_0 lxc1" [ style = bold]
-"container1_stop_0 18node2" -> "M-clone_stop_0" [ style = bold]
-"container1_stop_0 18node2" -> "M_stop_0 lxc1" [ style = bold]
 "container1_stop_0 18node2" -> "all_stopped" [ style = bold]
 "container1_stop_0 18node2" -> "container1_start_0 18node2" [ style = bold]
+"container1_stop_0 18node2" -> "stonith 'reboot' lxc1" [ style = bold]
 "container1_stop_0 18node2" [ style=bold color="green" fontcolor="black"]
 "lxc1_monitor_30000 18node2" [ style=bold color="green" fontcolor="black"]
 "lxc1_start_0 18node2" -> "B_monitor_10000 lxc1" [ style = bold]
@@ -42,4 +40,15 @@ digraph "g" {
 "lxc1_stop_0 18node2" -> "container1_stop_0 18node2" [ style = bold]
 "lxc1_stop_0 18node2" -> "lxc1_start_0 18node2" [ style = bold]
 "lxc1_stop_0 18node2" [ style=bold color="green" fontcolor="black"]
+"stonith 'reboot' lxc1" -> "B_stop_0 lxc1" [ style = bold]
+"stonith 'reboot' lxc1" -> "M-clone_stop_0" [ style = bold]
+"stonith 'reboot' lxc1" -> "M_stop_0 lxc1" [ style = bold]
+"stonith 'reboot' lxc1" -> "stonith_complete" [ style = bold]
+"stonith 'reboot' lxc1" [ style=bold color="green" fontcolor="orange"]
+"stonith_complete" -> "B_start_0 lxc1" [ style = bold]
+"stonith_complete" -> "M_start_0 lxc1" [ style = bold]
+"stonith_complete" -> "all_stopped" [ style = bold]
+"stonith_complete" -> "container1_start_0 18node2" [ style = bold]
+"stonith_complete" -> "lxc1_start_0 18node2" [ style = bold]
+"stonith_complete" [ style=bold color="green" fontcolor="orange"]
 }
diff --git a/pengine/test10/whitebox-fail1.exp b/pengine/test10/whitebox-fail1.exp
index 9629a76af..03e83c3b5 100644
--- a/pengine/test10/whitebox-fail1.exp
+++ b/pengine/test10/whitebox-fail1.exp
@@ -10,6 +10,9 @@
       <trigger>
         <rsc_op id="5" operation="stop" operation_key="container1_stop_0" on_node="18node2" on_node_uuid="2"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="45" operation="stonith_complete" operation_key="stonith_complete"/>
+      </trigger>
     </inputs>
   </synapse>
   <synapse id="1">
@@ -58,6 +61,9 @@
       <trigger>
         <rsc_op id="42" operation="start" operation_key="lxc1_start_0" on_node="18node2" on_node_uuid="2"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="45" operation="stonith_complete" operation_key="stonith_complete"/>
+      </trigger>
     </inputs>
   </synapse>
   <synapse id="4">
@@ -68,10 +74,10 @@
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="5" operation="stop" operation_key="container1_stop_0" on_node="18node2" on_node_uuid="2"/>
+        <pseudo_event id="30" operation="stop" operation_key="M-clone_stop_0"/>
       </trigger>
       <trigger>
-        <pseudo_event id="30" operation="stop" operation_key="M-clone_stop_0"/>
+        <pseudo_event id="46" operation="stonith" operation_key="stonith-lxc1-reboot" on_node="lxc1" on_node_uuid="lxc1"/>
       </trigger>
     </inputs>
   </synapse>
@@ -98,7 +104,7 @@
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="5" operation="stop" operation_key="container1_stop_0" on_node="18node2" on_node_uuid="2"/>
+        <pseudo_event id="46" operation="stonith" operation_key="stonith-lxc1-reboot" on_node="lxc1" on_node_uuid="lxc1"/>
       </trigger>
     </inputs>
   </synapse>
@@ -159,6 +165,9 @@
       <trigger>
         <rsc_op id="42" operation="start" operation_key="lxc1_start_0" on_node="18node2" on_node_uuid="2"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="45" operation="stonith_complete" operation_key="stonith_complete"/>
+      </trigger>
     </inputs>
   </synapse>
   <synapse id="11">
@@ -169,7 +178,7 @@
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="5" operation="stop" operation_key="container1_stop_0" on_node="18node2" on_node_uuid="2"/>
+        <pseudo_event id="46" operation="stonith" operation_key="stonith-lxc1-reboot" on_node="lxc1" on_node_uuid="lxc1"/>
       </trigger>
     </inputs>
   </synapse>
@@ -187,6 +196,9 @@
       <trigger>
         <rsc_op id="41" operation="stop" operation_key="lxc1_stop_0" on_node="18node2" on_node_uuid="2"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="45" operation="stonith_complete" operation_key="stonith_complete"/>
+      </trigger>
     </inputs>
   </synapse>
   <synapse id="13">
@@ -216,6 +228,33 @@
   </synapse>
   <synapse id="15">
     <action_set>
+      <pseudo_event id="46" operation="stonith" operation_key="stonith-lxc1-reboot" on_node="lxc1" on_node_uuid="lxc1">
+        <attributes CRM_meta_on_node="lxc1" CRM_meta_on_node_uuid="lxc1" CRM_meta_stonith_action="reboot" />
+        <downed>
+          <node id="lxc1"/>
+        </downed>
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="5" operation="stop" operation_key="container1_stop_0" on_node="18node2" on_node_uuid="2"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="16">
+    <action_set>
+      <pseudo_event id="45" operation="stonith_complete" operation_key="stonith_complete">
+        <attributes />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <pseudo_event id="46" operation="stonith" operation_key="stonith-lxc1-reboot" on_node="lxc1" on_node_uuid="lxc1"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="17">
+    <action_set>
       <pseudo_event id="11" operation="all_stopped" operation_key="all_stopped">
         <attributes />
       </pseudo_event>
@@ -233,6 +272,9 @@
       <trigger>
         <rsc_op id="41" operation="stop" operation_key="lxc1_stop_0" on_node="18node2" on_node_uuid="2"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="45" operation="stonith_complete" operation_key="stonith_complete"/>
+      </trigger>
     </inputs>
   </synapse>
 </transition_graph>
diff --git a/pengine/test10/whitebox-fail1.summary b/pengine/test10/whitebox-fail1.summary
index 158640750..1872e9a8b 100644
--- a/pengine/test10/whitebox-fail1.summary
+++ b/pengine/test10/whitebox-fail1.summary
@@ -22,20 +22,22 @@ Transition Summary:
 Executing cluster transition:
  * Resource action: lxc1            stop on 18node2
  * Resource action: container1      stop on 18node2
+ * Pseudo action:   stonith-lxc1-reboot on lxc1
+ * Pseudo action:   stonith_complete
+ * Resource action: container1      start on 18node2
  * Pseudo action:   M-clone_stop_0
  * Pseudo action:   B_stop_0
- * Resource action: container1      start on 18node2
+ * Resource action: lxc1            start on 18node2
+ * Resource action: lxc1            monitor=30000 on 18node2
  * Pseudo action:   M_stop_0
  * Pseudo action:   M-clone_stopped_0
  * Pseudo action:   M-clone_start_0
- * Resource action: lxc1            start on 18node2
- * Resource action: lxc1            monitor=30000 on 18node2
+ * Resource action: B               start on lxc1
  * Pseudo action:   all_stopped
  * Resource action: M               start on lxc1
  * Pseudo action:   M-clone_running_0
- * Resource action: B               start on lxc1
- * Resource action: M               monitor=10000 on lxc1
  * Resource action: B               monitor=10000 on lxc1
+ * Resource action: M               monitor=10000 on lxc1
 
 Revised cluster status:
 Online: [ 18node1 18node2 18node3 ]
diff --git a/pengine/test10/whitebox-fail2.dot b/pengine/test10/whitebox-fail2.dot
index 0f0fe26f6..c6380ea55 100644
--- a/pengine/test10/whitebox-fail2.dot
+++ b/pengine/test10/whitebox-fail2.dot
@@ -25,11 +25,9 @@ digraph "g" {
 "all_stopped" [ style=bold color="green" fontcolor="orange"]
 "container1_start_0 18node2" -> "lxc1_start_0 18node2" [ style = bold]
 "container1_start_0 18node2" [ style=bold color="green" fontcolor="black"]
-"container1_stop_0 18node2" -> "B_stop_0 lxc1" [ style = bold]
-"container1_stop_0 18node2" -> "M-clone_stop_0" [ style = bold]
-"container1_stop_0 18node2" -> "M_stop_0 lxc1" [ style = bold]
 "container1_stop_0 18node2" -> "all_stopped" [ style = bold]
 "container1_stop_0 18node2" -> "container1_start_0 18node2" [ style = bold]
+"container1_stop_0 18node2" -> "stonith 'reboot' lxc1" [ style = bold]
 "container1_stop_0 18node2" [ style=bold color="green" fontcolor="black"]
 "lxc1_monitor_30000 18node2" [ style=bold color="green" fontcolor="black"]
 "lxc1_start_0 18node2" -> "B_monitor_10000 lxc1" [ style = bold]
@@ -42,4 +40,15 @@ digraph "g" {
 "lxc1_stop_0 18node2" -> "container1_stop_0 18node2" [ style = bold]
 "lxc1_stop_0 18node2" -> "lxc1_start_0 18node2" [ style = bold]
 "lxc1_stop_0 18node2" [ style=bold color="green" fontcolor="black"]
+"stonith 'reboot' lxc1" -> "B_stop_0 lxc1" [ style = bold]
+"stonith 'reboot' lxc1" -> "M-clone_stop_0" [ style = bold]
+"stonith 'reboot' lxc1" -> "M_stop_0 lxc1" [ style = bold]
+"stonith 'reboot' lxc1" -> "stonith_complete" [ style = bold]
+"stonith 'reboot' lxc1" [ style=bold color="green" fontcolor="orange"]
+"stonith_complete" -> "B_start_0 lxc1" [ style = bold]
+"stonith_complete" -> "M_start_0 lxc1" [ style = bold]
+"stonith_complete" -> "all_stopped" [ style = bold]
+"stonith_complete" -> "container1_start_0 18node2" [ style = bold]
+"stonith_complete" -> "lxc1_start_0 18node2" [ style = bold]
+"stonith_complete" [ style=bold color="green" fontcolor="orange"]
 }
diff --git a/pengine/test10/whitebox-fail2.exp b/pengine/test10/whitebox-fail2.exp
index 9629a76af..03e83c3b5 100644
--- a/pengine/test10/whitebox-fail2.exp
+++ b/pengine/test10/whitebox-fail2.exp
@@ -10,6 +10,9 @@
       <trigger>
         <rsc_op id="5" operation="stop" operation_key="container1_stop_0" on_node="18node2" on_node_uuid="2"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="45" operation="stonith_complete" operation_key="stonith_complete"/>
+      </trigger>
     </inputs>
   </synapse>
   <synapse id="1">
@@ -58,6 +61,9 @@
       <trigger>
         <rsc_op id="42" operation="start" operation_key="lxc1_start_0" on_node="18node2" on_node_uuid="2"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="45" operation="stonith_complete" operation_key="stonith_complete"/>
+      </trigger>
     </inputs>
   </synapse>
   <synapse id="4">
@@ -68,10 +74,10 @@
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="5" operation="stop" operation_key="container1_stop_0" on_node="18node2" on_node_uuid="2"/>
+        <pseudo_event id="30" operation="stop" operation_key="M-clone_stop_0"/>
       </trigger>
       <trigger>
-        <pseudo_event id="30" operation="stop" operation_key="M-clone_stop_0"/>
+        <pseudo_event id="46" operation="stonith" operation_key="stonith-lxc1-reboot" on_node="lxc1" on_node_uuid="lxc1"/>
       </trigger>
     </inputs>
   </synapse>
@@ -98,7 +104,7 @@
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="5" operation="stop" operation_key="container1_stop_0" on_node="18node2" on_node_uuid="2"/>
+        <pseudo_event id="46" operation="stonith" operation_key="stonith-lxc1-reboot" on_node="lxc1" on_node_uuid="lxc1"/>
       </trigger>
     </inputs>
   </synapse>
@@ -159,6 +165,9 @@
       <trigger>
         <rsc_op id="42" operation="start" operation_key="lxc1_start_0" on_node="18node2" on_node_uuid="2"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="45" operation="stonith_complete" operation_key="stonith_complete"/>
+      </trigger>
     </inputs>
   </synapse>
   <synapse id="11">
@@ -169,7 +178,7 @@
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="5" operation="stop" operation_key="container1_stop_0" on_node="18node2" on_node_uuid="2"/>
+        <pseudo_event id="46" operation="stonith" operation_key="stonith-lxc1-reboot" on_node="lxc1" on_node_uuid="lxc1"/>
       </trigger>
     </inputs>
   </synapse>
@@ -187,6 +196,9 @@
       <trigger>
         <rsc_op id="41" operation="stop" operation_key="lxc1_stop_0" on_node="18node2" on_node_uuid="2"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="45" operation="stonith_complete" operation_key="stonith_complete"/>
+      </trigger>
     </inputs>
   </synapse>
   <synapse id="13">
@@ -216,6 +228,33 @@
   </synapse>
   <synapse id="15">
     <action_set>
+      <pseudo_event id="46" operation="stonith" operation_key="stonith-lxc1-reboot" on_node="lxc1" on_node_uuid="lxc1">
+        <attributes CRM_meta_on_node="lxc1" CRM_meta_on_node_uuid="lxc1" CRM_meta_stonith_action="reboot" />
+        <downed>
+          <node id="lxc1"/>
+        </downed>
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="5" operation="stop" operation_key="container1_stop_0" on_node="18node2" on_node_uuid="2"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="16">
+    <action_set>
+      <pseudo_event id="45" operation="stonith_complete" operation_key="stonith_complete">
+        <attributes />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <pseudo_event id="46" operation="stonith" operation_key="stonith-lxc1-reboot" on_node="lxc1" on_node_uuid="lxc1"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="17">
+    <action_set>
       <pseudo_event id="11" operation="all_stopped" operation_key="all_stopped">
         <attributes />
       </pseudo_event>
@@ -233,6 +272,9 @@
       <trigger>
         <rsc_op id="41" operation="stop" operation_key="lxc1_stop_0" on_node="18node2" on_node_uuid="2"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="45" operation="stonith_complete" operation_key="stonith_complete"/>
+      </trigger>
     </inputs>
   </synapse>
 </transition_graph>
diff --git a/pengine/test10/whitebox-fail2.summary b/pengine/test10/whitebox-fail2.summary
index ab40d99fe..5db6588f8 100644
--- a/pengine/test10/whitebox-fail2.summary
+++ b/pengine/test10/whitebox-fail2.summary
@@ -22,20 +22,22 @@ Transition Summary:
 Executing cluster transition:
  * Resource action: lxc1            stop on 18node2
  * Resource action: container1      stop on 18node2
+ * Pseudo action:   stonith-lxc1-reboot on lxc1
+ * Pseudo action:   stonith_complete
+ * Resource action: container1      start on 18node2
  * Pseudo action:   M-clone_stop_0
  * Pseudo action:   B_stop_0
- * Resource action: container1      start on 18node2
+ * Resource action: lxc1            start on 18node2
+ * Resource action: lxc1            monitor=30000 on 18node2
  * Pseudo action:   M_stop_0
  * Pseudo action:   M-clone_stopped_0
  * Pseudo action:   M-clone_start_0
- * Resource action: lxc1            start on 18node2
- * Resource action: lxc1            monitor=30000 on 18node2
+ * Resource action: B               start on lxc1
  * Pseudo action:   all_stopped
  * Resource action: M               start on lxc1
  * Pseudo action:   M-clone_running_0
- * Resource action: B               start on lxc1
- * Resource action: M               monitor=10000 on lxc1
  * Resource action: B               monitor=10000 on lxc1
+ * Resource action: M               monitor=10000 on lxc1
 
 Revised cluster status:
 Online: [ 18node1 18node2 18node3 ]
diff --git a/pengine/test10/whitebox-imply-stop-on-fence.dot b/pengine/test10/whitebox-imply-stop-on-fence.dot
index b3fd40be2..0e17a165e 100644
--- a/pengine/test10/whitebox-imply-stop-on-fence.dot
+++ b/pengine/test10/whitebox-imply-stop-on-fence.dot
@@ -6,6 +6,7 @@
 "R-lxc-01_kiff-01_stop_0 kiff-01" -> "R-lxc-01_kiff-01_start_0 kiff-02" [ style = bold]
 "R-lxc-01_kiff-01_stop_0 kiff-01" -> "all_stopped" [ style = bold]
 "R-lxc-01_kiff-01_stop_0 kiff-01" -> "shared0-clone_stop_0" [ style = bold]
+"R-lxc-01_kiff-01_stop_0 kiff-01" -> "stonith 'reboot' lxc-01_kiff-01" [ style = bold]
 "R-lxc-01_kiff-01_stop_0 kiff-01" [ style=bold color="green" fontcolor="orange"]
 "R-lxc-02_kiff-01_monitor_10000 kiff-02" [ style=bold color="green" fontcolor="black"]
 "R-lxc-02_kiff-01_start_0 kiff-02" -> "R-lxc-02_kiff-01_monitor_10000 kiff-02" [ style = bold]
@@ -14,7 +15,9 @@
 "R-lxc-02_kiff-01_stop_0 kiff-01" -> "R-lxc-02_kiff-01_start_0 kiff-02" [ style = bold]
 "R-lxc-02_kiff-01_stop_0 kiff-01" -> "all_stopped" [ style = bold]
 "R-lxc-02_kiff-01_stop_0 kiff-01" -> "shared0-clone_stop_0" [ style = bold]
+"R-lxc-02_kiff-01_stop_0 kiff-01" -> "stonith 'reboot' lxc-02_kiff-01" [ style = bold]
 "R-lxc-02_kiff-01_stop_0 kiff-01" [ style=bold color="green" fontcolor="orange"]
+"all_stopped" -> "fence-kiff-02_start_0 kiff-02" [ style = bold]
 "all_stopped" [ style=bold color="green" fontcolor="orange"]
 "clvmd-clone_stop_0" -> "clvmd-clone_stopped_0" [ style = bold]
 "clvmd-clone_stop_0" -> "clvmd_stop_0 kiff-01" [ style = bold]
@@ -74,8 +77,12 @@
 "stonith 'reboot' kiff-01" -> "shared0-clone_stop_0" [ style = bold]
 "stonith 'reboot' kiff-01" -> "shared0_stop_0 kiff-01" [ style = bold]
 "stonith 'reboot' kiff-01" -> "stonith_complete" [ style = bold]
-"stonith 'reboot' kiff-01" -> "vm-fs_stop_0 lxc-01_kiff-01" [ style = bold]
 "stonith 'reboot' kiff-01" [ style=bold color="green" fontcolor="black"]
+"stonith 'reboot' lxc-01_kiff-01" -> "stonith_complete" [ style = bold]
+"stonith 'reboot' lxc-01_kiff-01" -> "vm-fs_stop_0 lxc-01_kiff-01" [ style = bold]
+"stonith 'reboot' lxc-01_kiff-01" [ style=bold color="green" fontcolor="orange"]
+"stonith 'reboot' lxc-02_kiff-01" -> "stonith_complete" [ style = bold]
+"stonith 'reboot' lxc-02_kiff-01" [ style=bold color="green" fontcolor="orange"]
 "stonith_complete" -> "R-lxc-01_kiff-01_start_0 kiff-02" [ style = bold]
 "stonith_complete" -> "R-lxc-02_kiff-01_start_0 kiff-02" [ style = bold]
 "stonith_complete" -> "all_stopped" [ style = bold]
